# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from pal_walking_msgs/WalkingStatus.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg

class WalkingStatus(genpy.Message):
  _md5sum = "86de80b808fb27b3f11d218fa8d1c16e"
  _type = "pal_walking_msgs/WalkingStatus"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """Header header

geometry_msgs/Pose    hip_reference_pose

geometry_msgs/Pose[2] foot_reference_pose

geometry_msgs/Point zmp_reference

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  __slots__ = ['header','hip_reference_pose','foot_reference_pose','zmp_reference']
  _slot_types = ['std_msgs/Header','geometry_msgs/Pose','geometry_msgs/Pose[2]','geometry_msgs/Point']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,hip_reference_pose,foot_reference_pose,zmp_reference

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(WalkingStatus, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.hip_reference_pose is None:
        self.hip_reference_pose = geometry_msgs.msg.Pose()
      if self.foot_reference_pose is None:
        self.foot_reference_pose = [geometry_msgs.msg.Pose(),geometry_msgs.msg.Pose()]
      if self.zmp_reference is None:
        self.zmp_reference = geometry_msgs.msg.Point()
    else:
      self.header = std_msgs.msg.Header()
      self.hip_reference_pose = geometry_msgs.msg.Pose()
      self.foot_reference_pose = [geometry_msgs.msg.Pose(),geometry_msgs.msg.Pose()]
      self.zmp_reference = geometry_msgs.msg.Point()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d.pack(_x.hip_reference_pose.position.x, _x.hip_reference_pose.position.y, _x.hip_reference_pose.position.z, _x.hip_reference_pose.orientation.x, _x.hip_reference_pose.orientation.y, _x.hip_reference_pose.orientation.z, _x.hip_reference_pose.orientation.w))
      for val1 in self.foot_reference_pose:
        _v1 = val1.position
        _x = _v1
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v2 = val1.orientation
        _x = _v2
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
      _x = self
      buff.write(_struct_3d.pack(_x.zmp_reference.x, _x.zmp_reference.y, _x.zmp_reference.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.hip_reference_pose is None:
        self.hip_reference_pose = geometry_msgs.msg.Pose()
      if self.foot_reference_pose is None:
        self.foot_reference_pose = None
      if self.zmp_reference is None:
        self.zmp_reference = geometry_msgs.msg.Point()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.hip_reference_pose.position.x, _x.hip_reference_pose.position.y, _x.hip_reference_pose.position.z, _x.hip_reference_pose.orientation.x, _x.hip_reference_pose.orientation.y, _x.hip_reference_pose.orientation.z, _x.hip_reference_pose.orientation.w,) = _struct_7d.unpack(str[start:end])
      self.foot_reference_pose = []
      for i in range(0, 2):
        val1 = geometry_msgs.msg.Pose()
        _v3 = val1.position
        _x = _v3
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v4 = val1.orientation
        _x = _v4
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        self.foot_reference_pose.append(val1)
      _x = self
      start = end
      end += 24
      (_x.zmp_reference.x, _x.zmp_reference.y, _x.zmp_reference.z,) = _struct_3d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d.pack(_x.hip_reference_pose.position.x, _x.hip_reference_pose.position.y, _x.hip_reference_pose.position.z, _x.hip_reference_pose.orientation.x, _x.hip_reference_pose.orientation.y, _x.hip_reference_pose.orientation.z, _x.hip_reference_pose.orientation.w))
      for val1 in self.foot_reference_pose:
        _v5 = val1.position
        _x = _v5
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v6 = val1.orientation
        _x = _v6
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
      _x = self
      buff.write(_struct_3d.pack(_x.zmp_reference.x, _x.zmp_reference.y, _x.zmp_reference.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.hip_reference_pose is None:
        self.hip_reference_pose = geometry_msgs.msg.Pose()
      if self.foot_reference_pose is None:
        self.foot_reference_pose = None
      if self.zmp_reference is None:
        self.zmp_reference = geometry_msgs.msg.Point()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.hip_reference_pose.position.x, _x.hip_reference_pose.position.y, _x.hip_reference_pose.position.z, _x.hip_reference_pose.orientation.x, _x.hip_reference_pose.orientation.y, _x.hip_reference_pose.orientation.z, _x.hip_reference_pose.orientation.w,) = _struct_7d.unpack(str[start:end])
      self.foot_reference_pose = []
      for i in range(0, 2):
        val1 = geometry_msgs.msg.Pose()
        _v7 = val1.position
        _x = _v7
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v8 = val1.orientation
        _x = _v8
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        self.foot_reference_pose.append(val1)
      _x = self
      start = end
      end += 24
      (_x.zmp_reference.x, _x.zmp_reference.y, _x.zmp_reference.z,) = _struct_3d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3I = struct.Struct("<3I")
_struct_7d = struct.Struct("<7d")
_struct_4d = struct.Struct("<4d")
_struct_3d = struct.Struct("<3d")
